unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ImgList, ExtCtrls, ComCtrls, jpeg,Registry, StdCtrls,
  Buttons,inifiles;

type
  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    Cartelas1: TMenuItem;
    GerarCartelas1: TMenuItem;
    N1: TMenuItem;
    Sair2: TMenuItem;
    Sorteio1: TMenuItem;
    Sortear1: TMenuItem;
    N2: TMenuItem;
    Premiao1: TMenuItem;
    ImageList1: TImageList;
    Ajuda1: TMenuItem;
    Sobre1: TMenuItem;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    N3: TMenuItem;
    tulo1: TMenuItem;
    ImprimirCartelas1: TMenuItem;
    Autenticar1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    ComoUsaroBINGO1: TMenuItem;
    Configuraes1: TMenuItem;
    Cores1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Ajuda2: TMenuItem;
    Impresso1: TMenuItem;
    ImprimirCartelas2: TMenuItem;
    pnPass: TPanel;
    lbPass: TLabel;
    StaticText1: TStaticText;
    EditPass: TEdit;
    btnPass: TBitBtn;
    pnTela: TPanel;
    Image2: TImage;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    procedure GerarCartelas1Click(Sender: TObject);
    procedure Sortear1Click(Sender: TObject);
    procedure Sair2Click(Sender: TObject);
    procedure Premiao1Click(Sender: TObject);
    procedure Sobre1Click(Sender: TObject);
    procedure tulo1Click(Sender: TObject);
    procedure ImprimirCartelas1Click(Sender: TObject);
    procedure Autenticar1Click(Sender: TObject);
    procedure ComoUsaroBINGO1Click(Sender: TObject);
    procedure VKey;
    procedure FormActivate(Sender: TObject);
    function SysUserName: string;
    procedure FormCreate(Sender: TObject);
    procedure Cores1Click(Sender: TObject);
    procedure Ajuda2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ImprimirCartelas2Click(Sender: TObject);
    procedure EditPassKeyPress(Sender: TObject; var Key: Char);
    procedure btnPassClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  function AtivarSoftware:Boolean;export;stdcall;
var
  frmMain: TfrmMain;
  SerialKey:String[10];
  Serie:String;
  data:TIniFile;
  DirDados:String;
  grafico:TBitMap;
  PassWord:String;

implementation

uses Unit1, USorteio, UPremios, USobre, UTitulos, UCartelas, UAutenticar,
  UHelp,UKey, URegistrar, UConfig, UNovaCartela;

{$R *.dfm}
function AtivarSoftware:Boolean; external 'Ativa.dll';
procedure TfrmMain.GerarCartelas1Click(Sender: TObject);
begin
  frmCartelas := TfrmCartelas.create ( application );
  frmCartelas.Show; //Modal;
end;

procedure TfrmMain.Sortear1Click(Sender: TObject);
begin
  //frmSorteio.Show;
  frmSorteio := TfrmSorteio.create ( application );
  frmSorteio.Show; //Modal;
end;

procedure TfrmMain.Sair2Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.Premiao1Click(Sender: TObject);
begin
  //frmPremios.Show;
  frmPremios := TfrmPremios.create ( application );
  frmPremios.Show; //Modal;
end;

procedure TfrmMain.Sobre1Click(Sender: TObject);
begin
//frmSobre.Show;
  frmSobre := TfrmSobre.create ( application );
  frmSobre.Show; //Modal;

end;

procedure TfrmMain.tulo1Click(Sender: TObject);
begin
  frmTitulo := TfrmTitulo.create ( application );
  frmTitulo.Show;
end;

procedure TfrmMain.ImprimirCartelas1Click(Sender: TObject);
begin
  frmCartelas := TfrmCartelas.create ( application );
  frmVerCartelas := TfrmVerCartelas.create ( application );
  frmCartelas.Imprimir;
  frmCartelas:=Nil;
  frmVerCartelas:=Nil;
end;

procedure TfrmMain.Autenticar1Click(Sender: TObject);
begin
  //frmAutenticar:=TfrmAutenticar.Create(Application);
  frmAutenticar.Show;
end;

procedure TfrmMain.ComoUsaroBINGO1Click(Sender: TObject);
begin
  frmHelp.Show;
end;

procedure TfrmMain.vKey;
var
  sk,dv,vdv: String;
  Usuario: String;
begin
  Usuario := SysUserName;
if Serie = '' then Serie:='00000000';
//ShowMessage('Serie: ' + serie);
  sk:=Copy(Serie,1,8);
  dv:=Copy(Serie,10,1);
  vdv:=DV11(sk,8);
//if AtivarSoftware = true then dv := vdv;
//
if (dv = vdv) then Registrado := True else Registrado := False;
//if AtivarSoftware = false then registrado := False;
if (dv = vdv) then begin
  frmMain.Caption := 'BINGO' + '    Registrado para ' + Usuario ;
end;
//
end;
procedure TfrmMain.FormActivate(Sender: TObject);
begin
  Reg := TRegistry.Create;
try
  Reg.RootKey := HKEY_LOCAL_MACHINE;
//
//if not Reg.KeyExists('Software\Bingo') then Abort;
if Reg.KeyExists('Software\Bingo') then
begin
  Reg.OpenKey('Software\Bingo',True);
if Reg.ValueExists('SerialKey')  then
begin
//  if Reg.ReadString('SerialKey') = '' then abort;
  Serie:=Reg.readstring('SerialKey');
end;
end;
finally
  Reg.Free;
end;
  vKey;
end;
function TfrmMain.SysUserName: string;
var
  I: DWord;
begin
  I := 255;
  SetLength(Result, I);
  Windows.GetUserName(PChar(Result), I);
  Result := string(PChar(Result));
end;
procedure TfrmMain.FormCreate(Sender: TObject);
begin
PassWord:='Bingo';
pnTela.Align:=alClient;
pnTela.BringToFront;
//pnTela.SendToBack
pnPass.BringToFront;
//  grafico:= TBitmap.Create;
//  grafico.LoadFromFile (Caminho + 'imagem.bmp');
//if AtivarSoftware = True then  ShowMessage('Software Ativado');
//Configuraes............
end;

procedure TfrmMain.Cores1Click(Sender: TObject);
begin
  frmConfig.ShowModal;
end;

procedure TfrmMain.Ajuda2Click(Sender: TObject);
begin
frmSobre := TfrmSobre.create ( application );
frmSobre.Show; //Modal;
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
frmCartelas := TfrmCartelas.create ( application );
frmCartelas.Show; //Modal;
end;

procedure TfrmMain.BitBtn3Click(Sender: TObject);
begin
{
  frmCartelas := TfrmCartelas.create ( application );
  frmVerCartelas := TfrmVerCartelas.create ( application );
  frmCartelas.Imprimir;
  frmCartelas:=Nil;
  frmVerCartelas:=Nil;
}
with frmNovaCartela do begin
  QuickRep1.Preview;
end;
end;

procedure TfrmMain.BitBtn2Click(Sender: TObject);
begin
//frmAutenticar:=TfrmAutenticar.Create(Application);
  frmAutenticar.Show;
end;

procedure TfrmMain.BitBtn4Click(Sender: TObject);
begin
//frmSorteio.Show;
//SkinData1.Active:=False;
  frmSorteio := TfrmSorteio.create ( application );
  frmSorteio.Show; //Modal;
end;

procedure TfrmMain.BitBtn5Click(Sender: TObject);
begin
//frmPremios.Show;
  frmPremios := TfrmPremios.create ( application );
  frmPremios.Show; //Modal;
end;

procedure TfrmMain.BitBtn6Click(Sender: TObject);
begin
  frmTitulo := TfrmTitulo.create ( application );
  frmTitulo.Show;
end;

procedure TfrmMain.BitBtn7Click(Sender: TObject);
begin
  frmConfig.ShowModal;
end;

procedure TfrmMain.BitBtn8Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.FormPaint(Sender: TObject);
begin
//FrmMain.Canvas.Draw(0,0,grafico);
end;

procedure TfrmMain.ImprimirCartelas2Click(Sender: TObject);
begin
with frmNovaCartela do begin
  QuickRep1.Preview;
end;
end;

procedure TfrmMain.EditPassKeyPress(Sender: TObject; var Key: Char);
begin
//  if EditPass.Text = PassWord then btnPass.Enabled:=True else btnPass.Enabled:=False;
  if (Key = #13) and (EditPass.Text <> PassWord) then begin
    ShowMessage('Sua Senha  Invlida.'+ #13 + 'Tente novamente.');
    EditPass.Clear;
    EditPass.SetFocus;
    BtnPass.Enabled:=False;
  end;
end;

procedure TfrmMain.btnPassClick(Sender: TObject);
var
i : Integer;
begin
if  EditPass.Text <> PassWord then begin
     ShowMessage('Sua Senha  Invlida.'+ #13 + 'Tente novamente.');
     EditPass.Clear;
     EditPass.SetFocus;
end;
if EditPass.Text = PassWord then begin
for i := 0 to ComponentCount -1 do
  if Components[i] is TBitBtn then
  begin
  TBitBtn(Components[i]).Enabled := True;
  end;
pnTela.SendToBack;
pnPass.Visible:=False;
EditPass.Clear;
end;
end;

end.
