unit UAutenticar;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, DB, DBTables, Grids, DBGrids, StdCtrls,
  Mask, DBCtrls, dbcgrids, Buttons, Menus;

type
  TfrmAutenticar = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    StatusBar1: TStatusBar;
    Table1: TTable;
    DataSource1: TDataSource;
    Table1Autentica: TBooleanField;
    Table1CODIGO: TAutoIncField;
    Table1NUM_CARTELA: TFloatField;
    Table1SERIE: TStringField;
    DBCtrlGrid1: TDBCtrlGrid;
    DBText1: TDBText;
    BitBtn1: TBitBtn;
    DBCheckBox1: TDBCheckBox;
    BitBtn2: TBitBtn;
    ListBox1: TListBox;
    Label2: TLabel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel4: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Controle: TPageControl;
    Edit2: TEdit;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Bevel1: TBevel;
    Label5: TLabel;
    procedure Edit1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure Autenticar;
    procedure CartAutenticas;
    procedure Sequencia;
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure ControleEnter(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure DBCheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAutenticar: TfrmAutenticar;
  Caminho:String;
  Inicio,Fim,Num:Integer;
  Valida:Integer;
  CartValid:Array of integer;
  NCart:Integer;

implementation

{$R *.dfm}

procedure TFrmAutenticar.Sequencia;
begin
//
if Edit2.Text = '' then Inicio:=0 else Inicio := StrToInt(Edit2.Text);
if Edit3.Text = '' then Fim:=0 else Fim := StrToInt(Edit3.Text);
//
end;
procedure TfrmAutenticar.CartAutenticas;
begin
  ListBox1.Clear;
  dbCtrlGrid1.Visible:=False;
  ListBox1.Visible:=False;
  table1.First;
while not Table1.Eof do begin
  if (Table1Autentica.Value = True) then begin
    CartValid[Table1.RecNo]:=StrToInt(Table1Num_Cartela.Text);
    ListBox1.Items.Add(IntToStr(CartValid[Table1.RecNo]));
  end;
table1.Next;
end;
  dbCtrlGrid1.Visible:=True;
  ListBox1.Visible:=True;
end;
procedure TfrmAutenticar.Autenticar;
begin
DBCtrlGrid1.Visible:=False;
ListBox1.Visible:=False;
Table1.First;
while not table1.Eof do begin
  if (table1Num_Cartela.Value = Valida) then begin
    if (Table1Num_Cartela.Value = Valida) and (Table1Autentica.Value = True) then begin
      ShowMessage('A Cartela j est Autenticada!');
      Edit1.Clear;
      if dbCtrlGrid1.Visible = False then dbCtrlGrid1.Visible:=True;
      Abort;
    end;
  table1.Edit;
  Table1Autentica.Value:=True;
  table1.Post;
  end;
  table1.Next;
end;
  ListBox1.Clear;
  CartAutenticas;
  Edit1.Clear;
  Edit1.SetFocus;
  ListBox1.Visible:=True;
  DBCtrlGrid1.Visible:=True;
end;
procedure TfrmAutenticar.Edit1Change(Sender: TObject);
begin
  if Edit1.Text = '' then Valida := 0 else Valida:=StrToInt(Edit1.Text);
end;

procedure TfrmAutenticar.BitBtn1Click(Sender: TObject);
begin
table1.Refresh;
Close;
end;

procedure TfrmAutenticar.FormDestroy(Sender: TObject);
begin
frmAutenticar:=Nil;
end;

procedure TfrmAutenticar.BitBtn2Click(Sender: TObject);
begin
Autenticar;
end;

procedure TfrmAutenticar.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8,#13] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
  if key = #13 then begin
    ListBox1.Visible:=False;
    Table1.ControlsDisabled;
    dbCtrlGrid1.Visible:=False;
    Autenticar;
    dbCtrlGrid1.Visible:=True;
    Table1.First;
    Table1.EnableControls;
    ListBox1.Visible:=True;    
  end;
end;

procedure TfrmAutenticar.FormCreate(Sender: TObject);
begin
Caminho:=ExtractFilePath( Application.ExeName );
  With Table1 do begin
    Active:=False;
    DatabaseName:=Caminho;
    TableName:='Cartelas.db';
    Open;
    Edit;
  end;
NCart:=Table1.RecordCount;
StatusBar1.Panels[0].Text:=IntToStr(NCart);
SetLength(CartValid,NCart+1);
end;

procedure TfrmAutenticar.Edit2Change(Sender: TObject);
begin
//
Sequencia;
end;

procedure TfrmAutenticar.Edit3Change(Sender: TObject);
begin
//
Sequencia;
end;

procedure TfrmAutenticar.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
//
if key = #13 then begin
dbCtrlGrid1.Visible:=False;
for NCart:=Inicio to Fim do begin
Table1.First;
  while not Table1.Eof do begin
    if (Table1Num_Cartela.Value = NCart) and (Table1Autentica.Value = False) then begin
        Table1.Edit;
        Table1Autentica.Value:=True;
        Table1.Post;
    end;
    Table1.Next;
  end;
end;
CartAutenticas;
dbCtrlGrid1.Visible:=True;
Table1.First;
Edit2.Clear;
Edit3.Clear;
Edit2.SetFocus;
end;
end;
procedure TfrmAutenticar.ControleEnter(Sender: TObject);
begin
if Controle.ActivePage = TabSheet2 then Edit2.SetFocus else Edit1.SetFocus;
end;

procedure TfrmAutenticar.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
if key = #13 then Edit3.SetFocus;
end;

procedure TfrmAutenticar.DBCheckBox1Click(Sender: TObject);
begin
table1.Edit;
end;

end.
