unit UConfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,inifiles, ExtCtrls, StdCtrls, Buttons, ColorGrd, ComCtrls;

type
  TfrmConfig = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn8: TBitBtn;
    ColorBox1: TColorBox;
    ColorBox2: TColorBox;
    ColorBox3: TColorBox;
    Bevel1: TBevel;
    UpDown1: TUpDown;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure ColorBox2Change(Sender: TObject);
    procedure ColorBox3Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmConfig: TfrmConfig;
  Data:TInifile;
  DirDados:String;
  CorNumero,CorPainel,CorFundo:integer;
  Tempo:Integer;

implementation

{$R *.dfm}

procedure TfrmConfig.FormCreate(Sender: TObject);
begin
DirDados:=ExtractFilePath(Application.ExeName);
//
end;

procedure TfrmConfig.BitBtn8Click(Sender: TObject);
begin
Data := TIniFile.Create(DirDados + 'Data.ini');
//Gravar Configuraes...
Tempo:=StrToInt(Edit1.Text);
Data.WriteInteger('CORES','Fontes',CorNumero);
Data.WriteInteger('CORES','Painel',CorPainel);
Data.WriteInteger('CORES','Fundo',CorFundo);
Data.WriteInteger('TEMPO','T',Tempo);
//
Data.WriteString('REDE','IP',Edit2.Text );
Data.WriteString('REDE','PORTA',Edit3.Text );
Data.Free; //esta linha libera a varivel da memria
Close;
end;

procedure TfrmConfig.ColorBox1Change(Sender: TObject);
begin
CorNumero:=ColorBox1.Selected;
end;

procedure TfrmConfig.ColorBox2Change(Sender: TObject);
begin
CorPainel:=ColorBox2.Selected;
end;

procedure TfrmConfig.ColorBox3Change(Sender: TObject);
begin
CorFundo:=ColorBox3.Selected;
end;

procedure TfrmConfig.FormShow(Sender: TObject);
begin
Data:=TiniFile.Create(DirDados + 'Data.ini');
//Label2.Caption:=Data.ReadString('CORES','Fontes','');
//Label3.Caption:=Data.ReadString('CORES','Painel','');
//Label4.Caption:=Data.ReadString('CORES','Fundo','');
//
ColorBox1.Selected:= StrToInt(Data.ReadString('CORES','Fontes',''));
ColorBox2.Selected := StrToInt(Data.ReadString('CORES','Painel',''));
ColorBox3.Selected := StrToInt(Data.ReadString('CORES','Fundo',''));
Tempo:=StrToInt(Data.ReadString('TEMPO','T',''));
Edit1.Text:=Data.ReadString('TEMPO','T','');
Edit2.Text:=Data.ReadString('Rede','IP','');
Edit3.Text:=Data.ReadString('Rede','Porta','');
UpDown1.Position:=(Tempo div 6) * 100;
Data.Free;
end;

procedure TfrmConfig.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
Edit1.Text:=IntToStr((UpDown1.Position div 100) * 6);
Tempo:=StrToInt(Edit1.Text);
end;

procedure TfrmConfig.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  If not( key in['0'..'9',#8,#13] ) then
  begin
  //beep;{somente delphi 2.0 ou >}
  key:=#0;
  end;
end;

end.
